#include "counterthread.h"
#include "ui_counterthread.h"
#include"multithread.h"
#include<QThread>
#include<QDebug>
#include<QObject>
CounterThread::CounterThread(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::CounterThread)
{
    ui->setupUi(this);
    thread=new QThread();
    multithread=new Multithread();
     multithread->moveToThread(thread);
    connect(multithread, SIGNAL(valueChanged(QString)), ui->labelCounter, SLOT(setText(QString)));
    connect(multithread, SIGNAL(multithreadRequested()), thread, SLOT(start()));
    connect(thread, SIGNAL(started()), multithread, SLOT(doMultiThread()));
    connect(multithread, SIGNAL(finished()), thread, SLOT(quit()), Qt::DirectConnection);

}

CounterThread::~CounterThread()
{

    multithread->abort();
    thread->wait();
    qDebug()<<this->QObject::thread()->currentThreadId();
    delete thread;
    delete multithread;
    delete ui;


}

void CounterThread::on_actionStart_triggered()
{
    multithread->abort();
    thread->wait();
    multithread->requestThread();
}

void CounterThread::on_actionPause_triggered()
{
    multithread->abort();
    thread->wait();
}

void CounterThread::on_actionResume_triggered()
{
    multithread->abort();
    thread->wait();
    multithread->resume();
}
