        #include "counterthread.h"
        #include "multithread.h"
        #include <QTimer>
        #include <QEventLoop>
        #include <QThread>
        #include <QDebug>
        Multithread::Multithread(QObject *parent) :
            QObject(parent)
        {
            _working =false;
            _abort = false;
        }

        void Multithread::requestThread()
        {
            mutex.lock();
            _working = true;
            _abort = false;
            qDebug()<<thread()->currentThreadId();
            mutex.unlock();

            emit multithreadRequested();
        }

        void Multithread::abort()
        {
            mutex.lock();
            if (_working) {
                _abort = true;
                qDebug()<<thread()->currentThreadId();
            }
            mutex.unlock();
        }
        void Multithread::resume()
        {
        mutex.lock();
        if(!_working)
        {
        _abort = true;
        qDebug()<<thread()->currentThreadId();
        }
        mutex.unlock();
        pauseContd.wakeAll();
        emit resume();


        }

        void Multithread::doMultiThread()
        {
            qDebug()<<thread()->currentThreadId();


            long int iCounter=0;
            while(true)
            {
                iCounter++;
               // int a=iCounter;
                emit

                mutex.lock();
                bool abort = _abort;
                mutex.unlock();

                if (abort) {
                    qDebug()<<thread()->currentThreadId();
                    break;
                }

                QEventLoop loop;
                QTimer::singleShot(500, &loop, SLOT(quit()));
                loop.exec();
                emit valueChanged(QString::number(iCounter));

            }
            mutex.lock();
            _working = false;
            mutex.unlock();

            qDebug()<<thread()->currentThreadId();

            emit finished();
        }



